<!DOCTYPE html>
<html>
<head>
<meta charset="utf-8">
    <meta name="description" content="WebRTC code samples">
    <meta name="viewport" content="width=device-width, user-scalable=yes, initial-scale=1, maximum-scale=1">


    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.6.0/css/bootstrap.min.css" integrity="sha512-P5MgMn1jBN01asBgU0z60Qk4QxiXo86+wlFahKrsQf37c9cro517WzVSPPV1tDKzhku2iJ2FVgL67wG03SGnNA==" crossorigin="anonymous" />

<script src="adapter-latest.js"></script>

<script src="jquery-3.3.1.min.js"></script>
<!-- <script src="https://54.210.209.126:443/socket.io/socket.io.js"></script> -->
<script src="https://loclahost:443/socket.io/socket.io.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.6.0/js/bootstrap.min.js" integrity="sha512-XKa9Hemdy1Ui3KSGgJdgMyYlUg1gM+QhL6cnlyTe2qzMCYm4nAZ1PsVerQzTTXzonUR+dmswHqgJPuwCq1MaAg==" crossorigin="anonymous"></script>

<script src="mainTeacher2.js"></script>
<script src='https://8x8.vc/libs/external_api.min.js'></script>

<script type="text/javascript" src="build/pdf.js"></script>
</head>
<body>

  <div class="container">
    <div class="form-group">
      <button class="btn btn-danger" id="max">Max</button> 
      <button class="btn btn-primary" onclick="start()">Listen</button>
  
    </div>
  <br>
    <div class="row">
      <div class="col-md-6">
        <canvas id="pdfViewer" style="width:100%;"></canvas>
        
      </div>
      <div class="col-md-6">
        <div id="meetDiv" style="width:100%" class="col">
          <div id="meet"></div>
        </div>
      </div>

    </div>
    <button class="btn btn-danger" id="cancel">Cancel</button>    
</div>

        
<script>
    $("#cancel").click(function(){    
        window.localStorage.room = 0;      
        window.location.href = "index.html";
    });


    
    const room_name = window.localStorage.room;
 	const domain = 'meet.jit.si';
	const options = {
	    roomName: room_name,
	    width: "100%",
	    height: 500,
	    parentNode: document.querySelector('#meet')
	};
	const api = new JitsiMeetExternalAPI(domain, options);


     // Loaded via <script> tag, create shortcut to access PDF.js exports.
var pdfjsLib = window['pdfjs-dist/build/pdf'];
// The workerSrc property shall be specified.
pdfjsLib.GlobalWorkerOptions.workerSrc = 'build/pdf.worker.js';

var pdfDoc = null,
    pageNum = 1,
    pageRendering = false,
    pageNumPending = null,
    scale = 1,
    canvas = document.getElementById('pdfViewer'),
    ctx = canvas.getContext('2d');

var sign = 0;


$("#myPdf").on("change", function(e){
  var file = e.target.files[0];
  console.log(file);
  if(file.type == "application/pdf"){
    var fileReader = new FileReader();  
    fileReader.onload = function() {
      pdfDoc = new Uint8Array(this.result);
      pdfjsLib.getDocument({data: pdfDoc}).promise.then(function(pdfDoc_) {
        pdfDoc = pdfDoc_;
        document.getElementById('page_count').textContent = pdfDoc.numPages;
        renderPage(pageNum);
      });
    };
    fileReader.readAsArrayBuffer(file);
  }
});

function renderPage(num) {
  pageRendering = true;
  // Using promise to fetch the page
  pdfDoc.getPage(num).then(function(page) {
    var viewport = page.getViewport(scale);
    canvas.height = viewport.height;
    canvas.width = viewport.width;

    // Render PDF page into canvas context
    var renderContext = {
      canvasContext: ctx,
      viewport: viewport
    };
    var renderTask = page.render(renderContext);

    // Wait for rendering to finish
    renderTask.promise.then(function() {
      pageRendering = false;
      if (pageNumPending !== null) {
        // New page rendering is pending
        renderPage(pageNumPending);
        pageNumPending = null;
      }
    });
  });

  // Update page counters
  document.getElementById('page_num').textContent = num;
}

/**
 * If another page rendering in progress, waits until the rendering is
 * finised. Otherwise, executes rendering immediately.
 */
function queueRenderPage(num) {
  if (pageRendering) {
    pageNumPending = num;
  } else {
    renderPage(num);
  }
}

/**
 * Displays previous page.
 */
function onPrevPage() {
  if (pageNum <= 1) {
    return;
  }
  pageNum--;
  queueRenderPage(pageNum);
}
document.getElementById('prev').addEventListener('click', onPrevPage);

/**
 * Displays next page.
 */
function onNextPage() {
  if (pageNum >= pdfDoc.numPages) {
    return;
  }
  pageNum++;
  queueRenderPage(pageNum);
}
document.getElementById('next').addEventListener('click', onNextPage);

////

/* Get the documentElement (<html>) to display the page in fullscreen */
var elem = document.getElementById('pdfViewer');

/* View in fullscreen */
function onOpenScreen() {
  if (elem.requestFullscreen) {
    elem.requestFullscreen();
  } else if (elem.mozRequestFullScreen) { /* Firefox */
    elem.mozRequestFullScreen();
  } else if (elem.webkitRequestFullscreen) { /* Chrome, Safari and Opera */
    elem.webkitRequestFullscreen();
  } else if (elem.msRequestFullscreen) { /* IE/Edge */
    elem.msRequestFullscreen();
  }
}
document.getElementById('max').addEventListener('click', onOpenScreen);

function startSign(){
  var btn = document.getElementById("sign");
  if (sign==0) {
    sign = 1;    
    btn.innerHTML = 'Sign off';
  }else{
    sign = 0;    
    btn.innerHTML = 'Sign';
  }
}

function start(){
  if("webkitSpeechRecognition" in window || "SpeechRecognition" in window){
    var SpeechRecog = window.SpeechRecognition || window.webkitSpeechRecognition;
    var speechRecognizer = new SpeechRecog();
    speechRecognizer.continuous = true;
    speechRecognizer.interimResults = true;
    speechRecognizer.lang = "id-ID";
    speechRecognizer.start();
    var finalTranscripts = "";
    var temp = "";
    speechRecognizer.onresult = function(event){
      var interimTranscripts = "";
      for(var i=event.resultIndex; i<event.results.length; i++){
        var transcript = event.results[i][0].transcript;
        transcript.replace("\n", "<br>");
        interimTranscripts += transcript;
      }
      ctx.fillStyle = "white";
      ctx.fillRect(canvas.width/3, canvas.height-(canvas.height/10), ctx.measureText(temp).width+5, 21);
  		ctx.font = "20px Arial";
      ctx.fillStyle = "black";
      ctx.fillText(interimTranscripts, canvas.width/3, canvas.height-(canvas.height/14));
      temp = interimTranscripts;
      if (sign==1) {
        base_image = new Image();
        var word = temp.replace(" ", "");
        base_image.src = 'img/'+word+'.jpg';
        base_image.onload = function(){
          ctx.drawImage(base_image, canvas.width-(canvas.width/7), (canvas.height/2), 120, 150);
        }
      }
    };
    speechRecognizer.onerror = function(event){};
  }
  else{
    ctx.fillText("Your browser does not support that.", canvas.width/3, canvas.height-(canvas.height/13));
  }
}
</script>
</body>
</html>
